#include <list>
#include <iostream>

using namespace std;

int main()
{
    list<int> lista;
    int a;
    cin >> a;
    int niz[200000];
    for (int i = 0; i < a; i++)
    {
        cin >> niz[i];
        if ((i > 0) && niz[i - 1] > niz[i]) {
            lista.push_back(i);
        }
    }

    int b;
    cin >> b;
    for (int i = 0; i < b; i++)
    {
        int n;
        int m;
        bool jeste = true;
        bool ispucao = false;
        cin >> n >> m;
        int br = 0;

        for (list<int>::iterator j = lista.begin(); j != lista.end(); j++)
        {
            if (*j > m - 1) {
                break;
            }
            if (ispucao && (*j >= n)) {
                jeste = false;
                break;
            }
            if ((*j >= n) && !ispucao) {
                if (niz[*j - 2] > niz[*j])
                {
                    jeste = false;
                    break;
                }
                else
                    ispucao = true;
            }
        }
        if (jeste)
            cout << "DA" << endl;
        else
            cout << "NE" << endl;

    }
}